/* riprogress.h
 *
 *
 */

#ifndef riprogress_h
#define riprogress_h

#include <stdint.h>

/* for simplicity and efficiency reasons, we try to use only one data type */
typedef uint32_t rp_num_t;

/* instead of a struct we use an array of values:
struct riprogress
{
	rp_num_t	current_track;
	rp_num_t	total_tracks;
	rp_num_t	current_track_sec;
	rp_num_t	total_track_sec;
	rp_num_t	current_cd_sec;
	rp_num_t	total_cd_sec;
	rp_num_t	promillage_track;
	rp_num_t	promillage_cd;
};
*/

enum erp_progress_t
{
	erp_begin_rip	= 'BRip',
	erp_end_rip		= 'ERip',
	erp_begin_track	= 'BTrk',
	erp_end_track	= 'ETrk',
	erp_end_sector	= 'ESec'
};


enum erp_field_t
{
	erp_progress,
	erp_current_track,
	erp_total_tracks,
	erp_current_track_sec,
	erp_total_track_sec,
	erp_current_cd_sec,
	erp_total_cd_sec,
	erp_promillage_track,
	erp_promillage_cd,
	erp_num_fields
};

typedef rp_num_t rp_field_t [erp_num_fields];

/* without calling rp_enable, the other progress functions won't have any effect
   call rp_disable to mute */
void rp_enable ();
void rp_disable ();

/* the whole job should be surround by calls of this */
void rp_begin_rip (rp_num_t num_tracks, rp_num_t num_sectors);
void rp_end_rip ();

/* one track */
void rp_begin_track (const char* name, rp_num_t batch_track, rp_num_t num_sectors);
void rp_end_track (const char* name);

/* call this after reading one sector (or bunch of sectors) */
void rp_end_sector (rp_num_t sector, rp_num_t promille);

#endif 
